# this script generates data needed to verify all claims about
# Erdos' function f(n,3,4) as stated in arxiv:1203.4393v4
from flagmatic.all import *
problem = GraphProblem(5, forbid_induced=(4,0), density=(3,3), minimize=True)
construction = GraphBlowupConstruction("3:112233", phantom_edge=(1,2))
problem.set_extremal_construction(construction)
problem.solve_sdp()
problem.make_exact()
# Number of 5-vertex graphs that appear in the construction (+phantom edge)
# Number of sharp graphs 
# if equal, then these lists coincide by Lemma 6 in arxiv:1203.4393v4
print len(construction.subgraphs(5)),len(problem._sharp_graphs)
problem.write_certificate("34.js")
