# this script generates data needed to verify all claims about
# Erdos' function f(n,3,5) as stated in arxiv:1203.4393v4
from flagmatic.all import *
problem = GraphProblem(6, forbid_induced=(5,0), density=(3,3), minimize=True, type_orders=[3,4])
construction = GraphBlowupConstruction("4:11223344", phantom_edge=(1,2))
problem.set_extremal_construction(construction)
problem.solve_sdp(solver="sdpa_dd")
problem.make_exact(2^20)
# Number of 6-vertex graphs that appear in the construction (+phantom edge)
# Number of sharp graphs 
# if equal, then these lists coincide by Lemma 6 in arxiv:1203.4393v4
print len(construction.subgraphs(6)),len(problem._sharp_graphs)
problem.write_certificate("35.js")
