# this script generates data needed to verify all claims about
# Erdos' function f(n,3,6) as stated in arxiv:1203.4393v4
from flagmatic.all import *
problem = GraphProblem(7, forbid_induced=(6, 0), density=(3, 3), minimize=True, types=["1:", "3:", "3:12", "3:1213", "3:121323", "5:12131415232425343545"])
construction = GraphBlowupConstruction("5:1122334455", phantom_edge=(1, 2))
problem.set_extremal_construction(construction)
problem.solve_sdp(True, tolerance=1e-4)
problem.make_exact()
# Number of 7-vertex graphs that appear in the construction (+phantom edge)
# Number of sharp graphs 
# if equal, then these lists coincide by Lemma 6 in arxiv:1203.4393v4
print len(construction.subgraphs(7)),len(problem._sharp_graphs)
problem.write_certificate("36.js")
