# this script generates data needed to verify all claims about
# Erdos' function f(n,4,3) as stated in arxiv:1203.4393v4
from flagmatic.all import *
problem = GraphProblem(6, forbid_induced=(3,0), density=(4,6), minimize=True)
construction = GraphBlowupConstruction("5:12233445511122334455")
problem.set_extremal_construction(construction)
problem.solve_sdp()
problem.make_exact()
# Number of 6-vertex graphs that appear in the construction
# Number of sharp graphs 
# if equal, then these lists coincide by Lemma 5 in arxiv:1203.4393v4
print len(construction.subgraphs(6)),len(problem._sharp_graphs)
# rank condition of Section 4.1 in arxiv:1203.4393v4 for type tau_6
print problem.types[5]
print problem._exact_Q_matrices[5].nrows()
print problem._exact_Q_matrices[5].rank()
problem.write_certificate("43.js")
