(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     27873,        825]
NotebookOptionsPosition[     25925,        755]
NotebookOutlinePosition[     26381,        773]
CellTagsIndexPosition[     26338,        770]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "binary", " ", "sequences", " ", "with", " ", "even", " ", "number", " ", 
    "of", " ", "1", "s"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"v", "=", 
   RowBox[{"Select", "[", 
    RowBox[{
     RowBox[{"Tuples", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "5", "}"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"EvenQ", "[", 
       RowBox[{"Apply", "[", 
        RowBox[{"Plus", ",", "#"}], "]"}], "]"}], "&"}]}], "]"}]}]}]], "Input",\

 CellChangeTimes->{{3.540884122874988*^9, 3.540884217150963*^9}, {
   3.540884423095668*^9, 3.540884473359223*^9}, {3.540885038446514*^9, 
   3.5408850560402803`*^9}, 3.540885162741776*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.540885163403528*^9, 3.541012041255803*^9, 
  3.5410786164149427`*^9, 3.5411849979017353`*^9, 3.541217456027774*^9, 
  3.575813546979945*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "adjacency", " ", "matrix", " ", "of", " ", "Clebsch", " ", "graph"}], " ",
    "*)"}], "\[IndentingNewLine]", 
  RowBox[{"m", "=", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Count", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"v", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "+", 
           RowBox[{"v", "[", 
            RowBox[{"[", "j", "]"}], "]"}]}], ",", "1"}], "]"}], "\[Equal]", 
        "4"}], ",", "1", ",", "0"}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"i", ",", "16"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "16"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.540884227619282*^9, 3.540884310349031*^9}, {
   3.54088464190562*^9, 3.5408846451934967`*^9}, {3.540884686688891*^9, 
   3.540884761191985*^9}, {3.5408850083481827`*^9, 3.540885018635002*^9}, 
   3.5409112574272118`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1",
      ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
     ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0",
      ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", 
     ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0",
      ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
     ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0",
      ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
     ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", 
     ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
     ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
     ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
     ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", 
     ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
     ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1",
      ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
     ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0",
      ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0",
      ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0",
      ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.540911259794587*^9, 3.541012044203788*^9, 
  3.5410786179298763`*^9, 3.541184998881002*^9, 3.5412174568508472`*^9, 
  3.541218497198764*^9, 3.575813595959296*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"number", " ", "of", " ", "k"}], "-", 
     RowBox[{"tuples", " ", 
      RowBox[{"(", 
       RowBox[{"v1", ",", "...", ",", "vk"}], ")"}], " ", "st", " ", "v1"}]}],
     "=", 
    RowBox[{
    "1", " ", "and", " ", "they", " ", "span", " ", "no", " ", "edge"}]}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"independent", "[", "k_", "]"}], ":=", 
   RowBox[{
    RowBox[{"independent", "[", "k", "]"}], "=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"p", "=", 
         RowBox[{"Tuples", "[", 
          RowBox[{
           RowBox[{"Select", "[", 
            RowBox[{
             RowBox[{"Range", "[", "16", "]"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "#"}], "]"}], "]"}], "\[Equal]", "0"}], 
              "&"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"k", "-", "1"}], "}"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"z", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"0", ",", 
           RowBox[{"{", 
            RowBox[{"k", "-", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"k", "-", "1"}], "}"}]}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Length", "[", 
       RowBox[{"Select", "[", 
        RowBox[{"p", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"m", "[", 
             RowBox[{"[", 
              RowBox[{"#", ",", "#"}], "]"}], "]"}], "\[Equal]", "z"}], ")"}],
           "&"}]}], "]"}], "]"}]}], "\[IndentingNewLine]", 
     "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5408849715332603`*^9, 3.540884981185927*^9}, {
  3.540885116274803*^9, 3.540885117374537*^9}, {3.541185105095737*^9, 
  3.5411851146683807`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"independent", "[", "6", "]"}]], "Input",
 CellChangeTimes->{{3.540884984515963*^9, 3.540884989136724*^9}}],

Cell[BoxData["19211"], "Output",
 CellChangeTimes->{3.540884989900189*^9, 3.541012051786448*^9, 
  3.541078622774744*^9, 3.5411850030274982`*^9, 3.541185117336528*^9, 
  3.5412174624754953`*^9, 3.57581362134969*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"independent", "[", "7", "]"}]], "Input",
 CellChangeTimes->{{3.5408849921862507`*^9, 3.540884994566725*^9}}],

Cell[BoxData["98491"], "Output",
 CellChangeTimes->{
  3.540885000381467*^9, 3.541012062171624*^9, 3.541078629160482*^9, 
   3.541185008743683*^9, {3.5411851234768476`*^9, 3.5411851249325123`*^9}, 
   3.541217469548842*^9, 3.575813628495817*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"stability", " ", "for", " ", 
     RowBox[{"(", 
      RowBox[{"6", ",", "3"}], ")"}], " ", "and", " ", 
     RowBox[{"(", 
      RowBox[{"7", ",", "3"}], ")"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
    "we", " ", "define", " ", "p", " ", "that", " ", "spans", " ", "C_", 
     RowBox[{"5", "'"}], " ", "in", " ", "the", " ", "Clebsch", " ", 
     "graph"}]}], " ", "*)"}], " ", "\[IndentingNewLine]", 
  RowBox[{"v", "[", 
   RowBox[{"[", 
    RowBox[{"p", "=", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "7", ",", "9", ",", "4", ",", "13"}], 
      "}"}]}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.541078679649146*^9, 3.54107884110723*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.541078842775642*^9, 3.541185008830843*^9, 
  3.5412174696413317`*^9, 3.575813635736618*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "possible", " ", "sets", " ", "Z", " ", "when", " ", "we", " ", "remove", 
     " ", "z", " ", "from", " ", "p", " ", "except", " ", "we", " ", "do", 
     " ", "not", " ", "allow", " ", "z"}], "=", "00000"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"q", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Complement", "[", 
        RowBox[{"p", ",", 
         RowBox[{"{", "#", "}"}]}], "]"}], ")"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "7", ",", "9", ",", "4", ",", "13"}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.541078863587628*^9, 3.5410789182255087`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "4", ",", "7", ",", "9", ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "4", ",", "9", ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "4", ",", "7", ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "7", ",", "9", ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "4", ",", "7", ",", "9"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.541078920505395*^9, 3.541185011747604*^9, 
  3.541217474310993*^9, 3.575813662423328*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"equivalence", " ", "s"}], "-", "class"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"equiv", "[", 
    RowBox[{"i_Integer", ",", "s_List"}], "]"}], ":=", 
   RowBox[{"Select", "[", 
    RowBox[{
     RowBox[{"Range", "[", "16", "]"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"m", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"{", "i", "}"}], ",", "s"}], "]"}], "]"}], "\[Equal]", 
       RowBox[{"m", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"{", "#", "}"}], ",", "s"}], "]"}], "]"}]}], "&"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.541078938428537*^9, 3.541078965933329*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"suitable", " ", "z"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"suitable", "[", 
     RowBox[{"i_", ",", "j_"}], "]"}], ":=", 
    RowBox[{"Select", "[", 
     RowBox[{"q", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"a", "=", 
          RowBox[{"m", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"equiv", "[", 
              RowBox[{"i", ",", "#"}], "]"}], ",", 
             RowBox[{"equiv", "[", 
              RowBox[{"j", ",", "#"}], "]"}]}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Max", "[", "a", "]"}], "\[Equal]", 
          RowBox[{"Min", "[", "a", "]"}]}]}], ")"}], "&"}]}], "]"}]}], 
   ";"}]}]], "Input",
 CellChangeTimes->{{3.541079013336491*^9, 3.541079055492764*^9}, 
   3.575813687948761*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "suitable", " ", "z", " ", "with", " ", "some", " ", "output", " ", 
    "information"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"suitablePrint", "[", 
    RowBox[{"i_", ",", "j_"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"s", "=", 
      RowBox[{"Select", "[", 
       RowBox[{"q", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"a", "=", 
            RowBox[{"m", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"equiv", "[", 
                RowBox[{"i", ",", "#"}], "]"}], ",", 
               RowBox[{"equiv", "[", 
                RowBox[{"j", ",", "#"}], "]"}]}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Max", "[", "a", "]"}], "\[Equal]", 
            RowBox[{"Min", "[", "a", "]"}]}]}], ")"}], "&"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"z", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Complement", "[", 
          RowBox[{"p", ",", "#"}], "]"}], "&"}], ",", "s"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<x,y: \>\"", ",", 
       RowBox[{"v", "[", 
        RowBox[{"[", "i", "]"}], "]"}], ",", "\"\< \>\"", ",", " ", 
       RowBox[{"v", "[", 
        RowBox[{"[", "j", "]"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<List of suitable z: \>\"", ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"v", "[", 
           RowBox[{"[", "#", "]"}], "]"}], "&"}], ",", "z"}], "]"}]}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<Equivalence classs of x (per each z): \>\"", ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"v", "[", 
           RowBox[{"[", 
            RowBox[{"equiv", "[", 
             RowBox[{"i", ",", "#"}], "]"}], "]"}], "]"}], "&"}], ",", "s"}], 
        "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<Equivalence classs of y (per each z): \>\"", ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"v", "[", 
           RowBox[{"[", 
            RowBox[{"equiv", "[", 
             RowBox[{"j", ",", "#"}], "]"}], "]"}], "]"}], "&"}], ",", "s"}], 
        "]"}]}], "]"}]}], "\[IndentingNewLine]", ")"}]}]}]], "Input",
 CellChangeTimes->{{3.541217512936853*^9, 3.541217702274796*^9}, {
  3.541217936419417*^9, 3.541218031356575*^9}, {3.5412180944478073`*^9, 
  3.541218128998654*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"sample", " ", "use"}], ";", " ", 
    RowBox[{
    "this", " ", "is", " ", "Row", " ", "1", " ", "of", " ", "our", " ", 
     "table"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"suitablePrint", "[", 
   RowBox[{"1", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.541217704840392*^9, 3.541217709578561*^9}, {
   3.541217760057847*^9, 3.541217763230762*^9}, {3.5412185168100653`*^9, 
   3.541218529795698*^9}, 3.5758136917773743`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"x,y: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}],
  SequenceForm["x,y: ", {0, 0, 0, 0, 0}, " ", {0, 0, 0, 1, 1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.541217764311623*^9, {3.541217987918741*^9, 3.541218013070416*^9}, 
   3.541218046276534*^9, 3.541218098083042*^9, 3.541218530959693*^9, 
   3.5758136923070583`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"List of suitable z: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], "}"}]}], 
    "}"}]}],
  SequenceForm["List of suitable z: ", {{{1, 0, 0, 0, 1}}, {{0, 0, 1, 1, 0}}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.541217764311623*^9, {3.541217987918741*^9, 3.541218013070416*^9}, 
   3.541218046276534*^9, 3.541218098083042*^9, 3.541218530959693*^9, 
   3.575813692308361*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Equivalence classs of x (per each z): \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}]}], "}"}],
      ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
      "}"}]}], "}"}]}],
  SequenceForm[
  "Equivalence classs of x (per each z): ", {{{0, 0, 0, 0, 0}, {0, 1, 0, 1, 
   0}}, {{0, 0, 0, 0, 0}, {0, 1, 0, 0, 1}}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.541217764311623*^9, {3.541217987918741*^9, 3.541218013070416*^9}, 
   3.541218046276534*^9, 3.541218098083042*^9, 3.541218530959693*^9, 
   3.575813692310223*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Equivalence classs of y (per each z): \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], "}"}]}], 
    "}"}]}],
  SequenceForm[
  "Equivalence classs of y (per each z): ", {{{0, 0, 0, 1, 1}}, {{0, 0, 0, 1, 
   1}}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.541217764311623*^9, {3.541217987918741*^9, 3.541218013070416*^9}, 
   3.541218046276534*^9, 3.541218098083042*^9, 3.541218530959693*^9, 
   3.5758136923119783`*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Let", " ", "us", " ", "check", " ", "if", " ", "z", " ", "exists", " ", 
     "for", " ", "every", " ", "x"}], ",", "y"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"suitable", "[", 
          RowBox[{"i", ",", "j"}], "]"}], "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{"Print", "[", "\"\<NO!\>\"", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "16"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", 
       RowBox[{"i", "+", "1"}], ",", "16"}], "}"}]}], "]"}], ";"}]}]], "Input",\

 CellChangeTimes->{{3.5410790588744698`*^9, 3.541079185494265*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Exact", " ", "result", " ", "for", " ", 
       RowBox[{"(", 
        RowBox[{"6", ",", "3"}], ")"}], " ", "and", " ", 
       RowBox[{"(", 
        RowBox[{"7", ",", "3"}], ")"}]}], ":", " ", 
      RowBox[{"we", " ", "compute", " ", "gradient", " ", "of", " ", "X"}]}], 
     "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "00000", ",", " ", "00011", ",", " ", "00101", ",", " ", "00110"}], 
       "}"}], " ", "which", " ", "are", " ", "vertices", " ", "labeled", " ", 
      "1"}]}], ",", "2", ",", "3", ",", 
    RowBox[{"4", " ", "wrt", " ", "m"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"gradient", "[", "k_", "]"}], ":=", 
   RowBox[{
    RowBox[{"gradient", "[", "k", "]"}], "=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"p", "=", 
         RowBox[{"Tuples", "[", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{"5", ",", "16"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"k", "-", "1"}], "}"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"z", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"0", ",", 
           RowBox[{"{", 
            RowBox[{"k", "-", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"k", "-", "1"}], "}"}]}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Length", "[", 
        RowBox[{"Select", "[", 
         RowBox[{"p", ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"m", "[", 
              RowBox[{"[", 
               RowBox[{"#", ",", "#"}], "]"}], "]"}], "\[Equal]", "z"}], 
            ")"}], "&"}]}], "]"}], "]"}], "/", 
       RowBox[{"16", "^", 
        RowBox[{"(", 
         RowBox[{"k", "-", "1"}], ")"}]}]}]}], "\[IndentingNewLine]", 
     "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.541012315357666*^9, 3.541012372537405*^9}, {
  3.541012465366322*^9, 3.541012484301161*^9}, {3.541012898872981*^9, 
  3.5410129343676567`*^9}, {3.541078644116672*^9, 3.541078669443089*^9}, {
  3.5411851550316763`*^9, 3.541185156964644*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gradient", "[", "6", "]"}]], "Input",
 CellChangeTimes->{{3.541012561036008*^9, 3.5410125649689207`*^9}}],

Cell[BoxData[
 FractionBox["1437", "65536"]], "Output",
 CellChangeTimes->{3.541012679901207*^9, 3.541078630134038*^9, 
  3.541185031002706*^9, 3.54118515940792*^9, 3.575813766008099*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"gradient", "[", "6", "]"}], "-", 
  RowBox[{
   RowBox[{"independent", "[", "6", "]"}], "/", 
   RowBox[{"16", "^", "5"}]}]}]], "Input",
 CellChangeTimes->{{3.5410126846109333`*^9, 3.5410127207537193`*^9}}],

Cell[BoxData[
 FractionBox["3781", "1048576"]], "Output",
 CellChangeTimes->{{3.541012701686858*^9, 3.541012722934609*^9}, 
   3.541185162230525*^9, 3.575813770723607*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gradient", "[", "7", "]"}]], "Input"],

Cell[BoxData[
 FractionBox["14503", "2097152"]], "Output",
 CellChangeTimes->{
  3.541185066082406*^9, {3.541185175001243*^9, 3.541185179019432*^9}, 
   3.5758137819001503`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"gradient", "[", "7", "]"}], "-", 
  RowBox[{
   RowBox[{"independent", "[", "6", "]"}], "/", 
   RowBox[{"16", "^", "6"}]}]}]], "Input",
 CellChangeTimes->{{3.541185040152142*^9, 3.5411850486513557`*^9}}],

Cell[BoxData[
 FractionBox["96813", "16777216"]], "Output",
 CellChangeTimes->{3.541185080679739*^9, 3.575813782006049*^9}]
}, Open  ]]
},
WindowSize->{958, 867},
WindowMargins->{{Automatic, 225}, {Automatic, 0}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
ShowSelection->True,
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 20, \
2012)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 763, 21, 46, "Input"],
Cell[1345, 45, 1642, 38, 63, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3024, 88, 1028, 27, 80, "Input"],
Cell[4055, 117, 3693, 85, 148, "Output"]
}, Open  ]],
Cell[7763, 205, 1974, 57, 114, "Input"],
Cell[CellGroupData[{
Cell[9762, 266, 130, 2, 28, "Input"],
Cell[9895, 270, 215, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10147, 278, 132, 2, 28, "Input"],
Cell[10282, 282, 245, 4, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10564, 291, 739, 19, 63, "Input"],
Cell[11306, 312, 703, 17, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12046, 334, 725, 20, 46, "Input"],
Cell[12774, 356, 616, 15, 28, "Output"]
}, Open  ]],
Cell[13405, 374, 730, 23, 46, "Input"],
Cell[14138, 399, 910, 27, 63, "Input"],
Cell[15051, 428, 2701, 73, 165, "Input"],
Cell[CellGroupData[{
Cell[17777, 505, 518, 12, 46, "Input"],
Cell[CellGroupData[{
Cell[18320, 521, 593, 13, 22, "Print"],
Cell[18916, 536, 682, 18, 21, "Print"],
Cell[19601, 556, 997, 27, 22, "Print"],
Cell[20601, 585, 731, 21, 22, "Print"]
}, Open  ]]
}, Open  ]],
Cell[21359, 610, 809, 24, 46, "Input"],
Cell[22171, 636, 2262, 62, 131, "Input"],
Cell[CellGroupData[{
Cell[24458, 702, 129, 2, 28, "Input"],
Cell[24590, 706, 187, 3, 48, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24814, 714, 241, 6, 28, "Input"],
Cell[25058, 722, 171, 3, 48, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25266, 730, 61, 1, 28, "Input"],
Cell[25330, 733, 177, 4, 48, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25544, 742, 239, 6, 28, "Input"],
Cell[25786, 750, 123, 2, 82, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
